import { useRegisterMutation, useDeregisterMutation, User, TrainingDocument } from '../../gql'
import { FunctionComponent, useContext } from 'react'
import { UserContext } from '../../user/hooks'

const RegistrationButton: FunctionComponent<{ registrations?: User[] }> = ({ registrations }) => {
  const [register, registerData] = useRegisterMutation({
    refetchQueries: [{ query: TrainingDocument }],
    update: (cache, data) => {
      console.log('salie', cache, data)
    },
  })
  const [deregister, deregisterData] = useDeregisterMutation({
    refetchQueries: [{ query: TrainingDocument }],
    update: (cache, data) => {
      console.log('salie', cache, data)
    },
  })
  const { user } = useContext(UserContext)

  const isRegistered =
    registrations &&
    user?.data?.currentUser.id &&
    registrations.find((registeredUser) => registeredUser.id === user.data?.currentUser.id)
  const action = isRegistered ? () => deregister() : () => register()
  const label = isRegistered ? 'cancel' : 'register'

  return (
    <>
      <button
        type='button'
        onClick={action}
        disabled={registerData.loading || deregisterData.loading}
      >
        {label}
      </button>
      {registerData.error && registerData.error.message}
      {deregisterData.error && deregisterData.error.message}
    </>
  )
}

export default RegistrationButton
